
/*
 * Copyright (C) 2011 Technische Universitaet Muenchen
 * This file is part of the Sierpi project. For conditions of distribution and
 * use, please see the copyright notice in the file 'copyright.txt' at the root
 * directory of this package and the copyright notice at http://www5.in.tum.de/sierpi
 *
 * This file was automatically generated by the sierpinski code generator
 */


void V_e_bbb_forward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		V_o_bbn_forward(depth);
		V_o_bob_forward(depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_lifo_in.getNextDataPtr();
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char old_state = 0;

	if (depth < depth_limiter_max)
	{
		if (cKernelClass.should_refine(depth, element_data))
			old_state = 3;
	}

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	// spread refine/coarsening information
	outgoingEdgeStateInformation &= 0;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

void V_o_bbn_forward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		V_e_bnb_forward(depth);
		V_e_nbo_forward(depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_lifo_in.getNextDataPtr();
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char old_state = 0;

	if (depth < depth_limiter_max)
	{
		if (cKernelClass.should_refine(depth, element_data))
			old_state = 3;
	}

	if (depth > depth_limiter_min)
	{
		if (old_state == 0)
		{
			if (cKernelClass.should_coarsen(depth, element_data))
			{
				old_state = 2;
			}
		}
	}

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	// spread refine/coarsening information
	// spread coarsening information
	if (new_state == 2)
	{
		comm_right_edge_stack->push(2);
	}
	else
	{
		comm_right_edge_stack->push(0);
	}
	outgoingEdgeStateInformation &= 0;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

void V_e_bnb_forward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		V_o_bbn_forward(depth);
		V_o_nob_forward(depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_lifo_in.getNextDataPtr();
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char old_state = 0;

	if (depth < depth_limiter_max)
	{
		if (cKernelClass.should_refine(depth, element_data))
			old_state = 3;
	}

	if (depth > depth_limiter_min)
	{
		if (old_state == 0)
		{
			if (cKernelClass.should_coarsen(depth, element_data))
			{
				old_state = 2;
			}
		}
	}

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	// spread refine/coarsening information
	// spread coarsening information
	if (new_state == 2)
	{
		comm_left_edge_stack->push(2);
	}
	else
	{
		comm_left_edge_stack->push(0);
	}
	outgoingEdgeStateInformation &= 0;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

void V_o_nob_forward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		V_e_onn_forward(depth);
		V_e_bno_forward(depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_lifo_in.getNextDataPtr();
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char edge_right_trigger = comm_right_edge_stack->pop();
	incomingEdgeStateTransfer |= (edge_right_trigger&1) << 1;
	unsigned char old_state = 0;

	if (depth < depth_limiter_max)
	{
		if (cKernelClass.should_refine(depth, element_data))
			old_state = 3;
	}

	if (edge_right_trigger == 2)
	{
		if (depth > depth_limiter_min)
		{
			if (old_state == 0)
			{
				if (cKernelClass.should_coarsen(depth, element_data))
				{
					old_state = 2;
				}
			}
		}
	}

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	if (new_state != 2)
	{
		if (edge_right_trigger == 2)
			repeat_traversal = true;
	}
	else
	{
	}

	// spread refine/coarsening information
	comm_left_edge_stack->push((outgoingEdgeStateInformation >> 2) & 1);
	outgoingEdgeStateInformation &= 2;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

void V_e_onn_forward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		V_o_non_forward(depth);
		V_o_noo_forward(depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_lifo_in.getNextDataPtr();
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char hyp_trigger = comm_right_edge_stack->pop();
	incomingEdgeStateTransfer |= (hyp_trigger&1) << 2;
	unsigned char old_state = 0;

	if (depth < depth_limiter_max)
	{
		if (cKernelClass.should_refine(depth, element_data))
			old_state = 3;
	}

	if (depth > depth_limiter_min)
	{
		if (old_state == 0)
		{
			if (cKernelClass.should_coarsen(depth, element_data))
			{
				old_state = 2;
			}
		}
	}

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	if (new_state != 2)
	{
		if (hyp_trigger == 2)
			repeat_traversal = true;
	}
	else
	{
		if (hyp_trigger == 2)
			repeat_traversal = true;
	}

	// spread refine/coarsening information
	// spread coarsening information
	if (new_state == 2)
	{
		comm_left_edge_stack->push(2);
		comm_left_edge_stack->push(2);
	}
	else
	{
		comm_left_edge_stack->push(0);
		comm_left_edge_stack->push(0);
	}
	outgoingEdgeStateInformation &= 4;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

void V_o_non_forward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		V_e_onn_forward(depth);
		V_e_nno_forward(depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_lifo_in.getNextDataPtr();
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char edge_right_trigger = comm_right_edge_stack->pop();
	incomingEdgeStateTransfer |= (edge_right_trigger&1) << 1;
	unsigned char old_state = 0;

	if (depth < depth_limiter_max)
	{
		if (cKernelClass.should_refine(depth, element_data))
			old_state = 3;
	}

	if (edge_right_trigger == 2)
	{
		if (depth > depth_limiter_min)
		{
			if (old_state == 0)
			{
				if (cKernelClass.should_coarsen(depth, element_data))
				{
					old_state = 2;
				}
			}
		}
	}

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	if (new_state != 2)
	{
		if (edge_right_trigger == 2)
			repeat_traversal = true;
	}
	else
	{
	}

	// spread refine/coarsening information
	comm_left_edge_stack->push((outgoingEdgeStateInformation >> 2) & 1);
	// spread coarsening information
	if (new_state == 2)
	{
		comm_right_edge_stack->push(2);
	}
	else
	{
		comm_right_edge_stack->push(0);
	}
	outgoingEdgeStateInformation &= 2;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

void V_e_nno_forward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		V_o_onn_forward(depth);
		V_o_non_forward(depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_lifo_in.getNextDataPtr();
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char edge_left_trigger = comm_left_edge_stack->pop();
	incomingEdgeStateTransfer |= (edge_left_trigger&1) << 0;
	unsigned char old_state = 0;

	if (depth < depth_limiter_max)
	{
		if (cKernelClass.should_refine(depth, element_data))
			old_state = 3;
	}

	if (edge_left_trigger == 2)
	{
		if (depth > depth_limiter_min)
		{
			if (old_state == 0)
			{
				if (cKernelClass.should_coarsen(depth, element_data))
				{
					old_state = 2;
				}
			}
		}
	}

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	if (new_state != 2)
	{
		if (edge_left_trigger == 2)
			repeat_traversal = true;
	}
	else
	{
	}

	// spread refine/coarsening information
	comm_right_edge_stack->push((outgoingEdgeStateInformation >> 2) & 1);
	// spread coarsening information
	if (new_state == 2)
	{
		comm_left_edge_stack->push(2);
	}
	else
	{
		comm_left_edge_stack->push(0);
	}
	outgoingEdgeStateInformation &= 1;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

void V_o_onn_forward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		V_e_nno_forward(depth);
		V_e_noo_forward(depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_lifo_in.getNextDataPtr();
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char hyp_trigger = comm_left_edge_stack->pop();
	incomingEdgeStateTransfer |= (hyp_trigger&1) << 2;
	unsigned char old_state = 0;

	if (depth < depth_limiter_max)
	{
		if (cKernelClass.should_refine(depth, element_data))
			old_state = 3;
	}

	if (depth > depth_limiter_min)
	{
		if (old_state == 0)
		{
			if (cKernelClass.should_coarsen(depth, element_data))
			{
				old_state = 2;
			}
		}
	}

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	if (new_state != 2)
	{
		if (hyp_trigger == 2)
			repeat_traversal = true;
	}
	else
	{
		if (hyp_trigger == 2)
			repeat_traversal = true;
	}

	// spread refine/coarsening information
	// spread coarsening information
	if (new_state == 2)
	{
		comm_right_edge_stack->push(2);
		comm_right_edge_stack->push(2);
	}
	else
	{
		comm_right_edge_stack->push(0);
		comm_right_edge_stack->push(0);
	}
	outgoingEdgeStateInformation &= 4;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

void V_e_noo_forward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		V_o_onn_forward(depth);
		V_o_oon_forward(depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_lifo_in.getNextDataPtr();
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char edge_left_trigger = comm_left_edge_stack->pop();
	incomingEdgeStateTransfer |= (edge_left_trigger&1) << 0;
	unsigned char edge_right_trigger = comm_left_edge_stack->pop();
	incomingEdgeStateTransfer |= (edge_right_trigger&1) << 1;
	unsigned char old_state = 0;

	if (depth < depth_limiter_max)
	{
		if (cKernelClass.should_refine(depth, element_data))
			old_state = 3;
	}

	if ((edge_left_trigger == 2) && (edge_right_trigger == 2))
	{
		if (depth > depth_limiter_min)
		{
			if (old_state == 0)
			{
				if (cKernelClass.should_coarsen(depth, element_data))
				{
					old_state = 2;
				}
			}
		}
	}

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	if (new_state != 2)
	{
		if ((edge_left_trigger == 2) || (edge_right_trigger == 2))
			repeat_traversal = true;
	}
	else
	{
	}

	// spread refine/coarsening information
	comm_right_edge_stack->push((outgoingEdgeStateInformation >> 2) & 1);
	outgoingEdgeStateInformation &= 3;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

void V_o_oon_forward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		V_e_ono_forward(depth);
		V_e_noo_forward(depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_lifo_in.getNextDataPtr();
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char hyp_trigger = comm_left_edge_stack->pop();
	incomingEdgeStateTransfer |= (hyp_trigger&1) << 2;
	unsigned char edge_right_trigger = comm_right_edge_stack->pop();
	incomingEdgeStateTransfer |= (edge_right_trigger&1) << 1;
	unsigned char old_state = 0;

	if (depth < depth_limiter_max)
	{
		if (cKernelClass.should_refine(depth, element_data))
			old_state = 3;
	}

	if (edge_right_trigger == 2)
	{
		if (depth > depth_limiter_min)
		{
			if (old_state == 0)
			{
				if (cKernelClass.should_coarsen(depth, element_data))
				{
					old_state = 2;
				}
			}
		}
	}

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	if (new_state != 2)
	{
		if ((edge_right_trigger == 2) || (hyp_trigger == 2))
			repeat_traversal = true;
	}
	else
	{
		if (hyp_trigger == 2)
			repeat_traversal = true;
	}

	// spread refine/coarsening information
	// spread coarsening information
	if (new_state == 2)
	{
		comm_right_edge_stack->push(2);
	}
	else
	{
		comm_right_edge_stack->push(0);
	}
	outgoingEdgeStateInformation &= 6;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

void V_e_ono_forward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		V_o_oon_forward(depth);
		V_o_noo_forward(depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_lifo_in.getNextDataPtr();
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char hyp_trigger = comm_right_edge_stack->pop();
	incomingEdgeStateTransfer |= (hyp_trigger&1) << 2;
	unsigned char edge_left_trigger = comm_left_edge_stack->pop();
	incomingEdgeStateTransfer |= (edge_left_trigger&1) << 0;
	unsigned char old_state = 0;

	if (depth < depth_limiter_max)
	{
		if (cKernelClass.should_refine(depth, element_data))
			old_state = 3;
	}

	if (edge_left_trigger == 2)
	{
		if (depth > depth_limiter_min)
		{
			if (old_state == 0)
			{
				if (cKernelClass.should_coarsen(depth, element_data))
				{
					old_state = 2;
				}
			}
		}
	}

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	if (new_state != 2)
	{
		if ((edge_left_trigger == 2) || (hyp_trigger == 2))
			repeat_traversal = true;
	}
	else
	{
		if (hyp_trigger == 2)
			repeat_traversal = true;
	}

	// spread refine/coarsening information
	// spread coarsening information
	if (new_state == 2)
	{
		comm_left_edge_stack->push(2);
	}
	else
	{
		comm_left_edge_stack->push(0);
	}
	outgoingEdgeStateInformation &= 5;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

void V_o_noo_forward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		V_e_onn_forward(depth);
		V_e_ono_forward(depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_lifo_in.getNextDataPtr();
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char edge_right_trigger = comm_right_edge_stack->pop();
	incomingEdgeStateTransfer |= (edge_right_trigger&1) << 1;
	unsigned char edge_left_trigger = comm_right_edge_stack->pop();
	incomingEdgeStateTransfer |= (edge_left_trigger&1) << 0;
	unsigned char old_state = 0;

	if (depth < depth_limiter_max)
	{
		if (cKernelClass.should_refine(depth, element_data))
			old_state = 3;
	}

	if ((edge_left_trigger == 2) && (edge_right_trigger == 2))
	{
		if (depth > depth_limiter_min)
		{
			if (old_state == 0)
			{
				if (cKernelClass.should_coarsen(depth, element_data))
				{
					old_state = 2;
				}
			}
		}
	}

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	if (new_state != 2)
	{
		if ((edge_left_trigger == 2) || (edge_right_trigger == 2))
			repeat_traversal = true;
	}
	else
	{
	}

	// spread refine/coarsening information
	comm_left_edge_stack->push((outgoingEdgeStateInformation >> 2) & 1);
	outgoingEdgeStateInformation &= 3;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

void V_e_bno_forward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		V_o_obn_forward(depth);
		V_o_nob_forward(depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_lifo_in.getNextDataPtr();
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char edge_left_trigger = comm_left_edge_stack->pop();
	incomingEdgeStateTransfer |= (edge_left_trigger&1) << 0;
	unsigned char old_state = 0;

	if (depth < depth_limiter_max)
	{
		if (cKernelClass.should_refine(depth, element_data))
			old_state = 3;
	}

	if (edge_left_trigger == 2)
	{
		if (depth > depth_limiter_min)
		{
			if (old_state == 0)
			{
				if (cKernelClass.should_coarsen(depth, element_data))
				{
					old_state = 2;
				}
			}
		}
	}

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	if (new_state != 2)
	{
		if (edge_left_trigger == 2)
			repeat_traversal = true;
	}
	else
	{
	}

	// spread refine/coarsening information
	// spread coarsening information
	if (new_state == 2)
	{
		comm_left_edge_stack->push(2);
	}
	else
	{
		comm_left_edge_stack->push(0);
	}
	outgoingEdgeStateInformation &= 1;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

void V_o_obn_forward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		V_e_bno_forward(depth);
		V_e_noo_forward(depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_lifo_in.getNextDataPtr();
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char hyp_trigger = comm_left_edge_stack->pop();
	incomingEdgeStateTransfer |= (hyp_trigger&1) << 2;
	unsigned char old_state = 0;

	if (depth < depth_limiter_max)
	{
		if (cKernelClass.should_refine(depth, element_data))
			old_state = 3;
	}

	if (depth > depth_limiter_min)
	{
		if (old_state == 0)
		{
			if (cKernelClass.should_coarsen(depth, element_data))
			{
				old_state = 2;
			}
		}
	}

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	if (new_state != 2)
	{
		if (hyp_trigger == 2)
			repeat_traversal = true;
	}
	else
	{
		if (hyp_trigger == 2)
			repeat_traversal = true;
	}

	// spread refine/coarsening information
	// spread coarsening information
	if (new_state == 2)
	{
		comm_right_edge_stack->push(2);
	}
	else
	{
		comm_right_edge_stack->push(0);
	}
	outgoingEdgeStateInformation &= 4;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

void V_e_nbo_forward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		V_o_onn_forward(depth);
		V_o_bon_forward(depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_lifo_in.getNextDataPtr();
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char edge_left_trigger = comm_left_edge_stack->pop();
	incomingEdgeStateTransfer |= (edge_left_trigger&1) << 0;
	unsigned char old_state = 0;

	if (depth < depth_limiter_max)
	{
		if (cKernelClass.should_refine(depth, element_data))
			old_state = 3;
	}

	if (edge_left_trigger == 2)
	{
		if (depth > depth_limiter_min)
		{
			if (old_state == 0)
			{
				if (cKernelClass.should_coarsen(depth, element_data))
				{
					old_state = 2;
				}
			}
		}
	}

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	if (new_state != 2)
	{
		if (edge_left_trigger == 2)
			repeat_traversal = true;
	}
	else
	{
	}

	// spread refine/coarsening information
	comm_right_edge_stack->push((outgoingEdgeStateInformation >> 2) & 1);
	outgoingEdgeStateInformation &= 1;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

void V_o_bon_forward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		V_e_onb_forward(depth);
		V_e_nbo_forward(depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_lifo_in.getNextDataPtr();
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char edge_right_trigger = comm_right_edge_stack->pop();
	incomingEdgeStateTransfer |= (edge_right_trigger&1) << 1;
	unsigned char old_state = 0;

	if (depth < depth_limiter_max)
	{
		if (cKernelClass.should_refine(depth, element_data))
			old_state = 3;
	}

	if (edge_right_trigger == 2)
	{
		if (depth > depth_limiter_min)
		{
			if (old_state == 0)
			{
				if (cKernelClass.should_coarsen(depth, element_data))
				{
					old_state = 2;
				}
			}
		}
	}

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	if (new_state != 2)
	{
		if (edge_right_trigger == 2)
			repeat_traversal = true;
	}
	else
	{
	}

	// spread refine/coarsening information
	// spread coarsening information
	if (new_state == 2)
	{
		comm_right_edge_stack->push(2);
	}
	else
	{
		comm_right_edge_stack->push(0);
	}
	outgoingEdgeStateInformation &= 2;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

void V_e_onb_forward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		V_o_bon_forward(depth);
		V_o_noo_forward(depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_lifo_in.getNextDataPtr();
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char hyp_trigger = comm_right_edge_stack->pop();
	incomingEdgeStateTransfer |= (hyp_trigger&1) << 2;
	unsigned char old_state = 0;

	if (depth < depth_limiter_max)
	{
		if (cKernelClass.should_refine(depth, element_data))
			old_state = 3;
	}

	if (depth > depth_limiter_min)
	{
		if (old_state == 0)
		{
			if (cKernelClass.should_coarsen(depth, element_data))
			{
				old_state = 2;
			}
		}
	}

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	if (new_state != 2)
	{
		if (hyp_trigger == 2)
			repeat_traversal = true;
	}
	else
	{
		if (hyp_trigger == 2)
			repeat_traversal = true;
	}

	// spread refine/coarsening information
	// spread coarsening information
	if (new_state == 2)
	{
		comm_left_edge_stack->push(2);
	}
	else
	{
		comm_left_edge_stack->push(0);
	}
	outgoingEdgeStateInformation &= 4;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

void V_o_bob_forward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		V_e_onb_forward(depth);
		V_e_bbo_forward(depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_lifo_in.getNextDataPtr();
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char edge_right_trigger = comm_right_edge_stack->pop();
	incomingEdgeStateTransfer |= (edge_right_trigger&1) << 1;
	unsigned char old_state = 0;

	if (depth < depth_limiter_max)
	{
		if (cKernelClass.should_refine(depth, element_data))
			old_state = 3;
	}

	if (edge_right_trigger == 2)
	{
		if (depth > depth_limiter_min)
		{
			if (old_state == 0)
			{
				if (cKernelClass.should_coarsen(depth, element_data))
				{
					old_state = 2;
				}
			}
		}
	}

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	if (new_state != 2)
	{
		if (edge_right_trigger == 2)
			repeat_traversal = true;
	}
	else
	{
	}

	// spread refine/coarsening information
	outgoingEdgeStateInformation &= 2;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

void V_e_bbo_forward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		V_o_obn_forward(depth);
		V_o_bob_forward(depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_lifo_in.getNextDataPtr();
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char edge_left_trigger = comm_left_edge_stack->pop();
	incomingEdgeStateTransfer |= (edge_left_trigger&1) << 0;
	unsigned char old_state = 0;

	if (depth < depth_limiter_max)
	{
		if (cKernelClass.should_refine(depth, element_data))
			old_state = 3;
	}

	if (edge_left_trigger == 2)
	{
		if (depth > depth_limiter_min)
		{
			if (old_state == 0)
			{
				if (cKernelClass.should_coarsen(depth, element_data))
				{
					old_state = 2;
				}
			}
		}
	}

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	if (new_state != 2)
	{
		if (edge_left_trigger == 2)
			repeat_traversal = true;
	}
	else
	{
	}

	// spread refine/coarsening information
	outgoingEdgeStateInformation &= 1;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

void V_o_bbb_forward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		V_e_bnb_forward(depth);
		V_e_bbo_forward(depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_lifo_in.getNextDataPtr();
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char old_state = 0;

	if (depth < depth_limiter_max)
	{
		if (cKernelClass.should_refine(depth, element_data))
			old_state = 3;
	}

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	// spread refine/coarsening information
	outgoingEdgeStateInformation &= 0;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

void V_e_nnn_forward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		V_o_nnn_forward(depth);
		V_o_non_forward(depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_lifo_in.getNextDataPtr();
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char old_state = 0;

	if (depth < depth_limiter_max)
	{
		if (cKernelClass.should_refine(depth, element_data))
			old_state = 3;
	}

	if (depth > depth_limiter_min)
	{
		if (old_state == 0)
		{
			if (cKernelClass.should_coarsen(depth, element_data))
			{
				old_state = 2;
			}
		}
	}

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	// spread refine/coarsening information
	comm_right_edge_stack->push((outgoingEdgeStateInformation >> 2) & 1);
	// spread coarsening information
	if (new_state == 2)
	{
		comm_left_edge_stack->push(2);
		comm_left_edge_stack->push(2);
	}
	else
	{
		comm_left_edge_stack->push(0);
		comm_left_edge_stack->push(0);
	}
	outgoingEdgeStateInformation &= 0;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

void V_o_nnn_forward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		V_e_nnn_forward(depth);
		V_e_nno_forward(depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_lifo_in.getNextDataPtr();
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char old_state = 0;

	if (depth < depth_limiter_max)
	{
		if (cKernelClass.should_refine(depth, element_data))
			old_state = 3;
	}

	if (depth > depth_limiter_min)
	{
		if (old_state == 0)
		{
			if (cKernelClass.should_coarsen(depth, element_data))
			{
				old_state = 2;
			}
		}
	}

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	// spread refine/coarsening information
	comm_left_edge_stack->push((outgoingEdgeStateInformation >> 2) & 1);
	// spread coarsening information
	if (new_state == 2)
	{
		comm_right_edge_stack->push(2);
		comm_right_edge_stack->push(2);
	}
	else
	{
		comm_right_edge_stack->push(0);
		comm_right_edge_stack->push(0);
	}
	outgoingEdgeStateInformation &= 0;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

void V_e_ooo_forward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		V_o_oon_forward(depth);
		V_o_ooo_forward(depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_lifo_in.getNextDataPtr();
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char hyp_trigger = comm_right_edge_stack->pop();
	incomingEdgeStateTransfer |= (hyp_trigger&1) << 2;
	unsigned char edge_left_trigger = comm_left_edge_stack->pop();
	incomingEdgeStateTransfer |= (edge_left_trigger&1) << 0;
	unsigned char edge_right_trigger = comm_left_edge_stack->pop();
	incomingEdgeStateTransfer |= (edge_right_trigger&1) << 1;
	unsigned char old_state = 0;

	if (depth < depth_limiter_max)
	{
		if (cKernelClass.should_refine(depth, element_data))
			old_state = 3;
	}

	if ((edge_left_trigger == 2) && (edge_right_trigger == 2))
	{
		if (depth > depth_limiter_min)
		{
			if (old_state == 0)
			{
				if (cKernelClass.should_coarsen(depth, element_data))
				{
					old_state = 2;
				}
			}
		}
	}

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	if (new_state != 2)
	{
		if ((edge_left_trigger == 2) || (edge_right_trigger == 2) || (hyp_trigger == 2))
			repeat_traversal = true;
	}
	else
	{
		if (hyp_trigger == 2)
			repeat_traversal = true;
	}

	// spread refine/coarsening information
	outgoingEdgeStateInformation &= 7;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

void V_o_ooo_forward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		V_e_ono_forward(depth);
		V_e_ooo_forward(depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_lifo_in.getNextDataPtr();
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char hyp_trigger = comm_left_edge_stack->pop();
	incomingEdgeStateTransfer |= (hyp_trigger&1) << 2;
	unsigned char edge_right_trigger = comm_right_edge_stack->pop();
	incomingEdgeStateTransfer |= (edge_right_trigger&1) << 1;
	unsigned char edge_left_trigger = comm_right_edge_stack->pop();
	incomingEdgeStateTransfer |= (edge_left_trigger&1) << 0;
	unsigned char old_state = 0;

	if (depth < depth_limiter_max)
	{
		if (cKernelClass.should_refine(depth, element_data))
			old_state = 3;
	}

	if ((edge_left_trigger == 2) && (edge_right_trigger == 2))
	{
		if (depth > depth_limiter_min)
		{
			if (old_state == 0)
			{
				if (cKernelClass.should_coarsen(depth, element_data))
				{
					old_state = 2;
				}
			}
		}
	}

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	if (new_state != 2)
	{
		if ((edge_left_trigger == 2) || (edge_right_trigger == 2) || (hyp_trigger == 2))
			repeat_traversal = true;
	}
	else
	{
		if (hyp_trigger == 2)
			repeat_traversal = true;
	}

	// spread refine/coarsening information
	outgoingEdgeStateInformation &= 7;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

void V_e_bnn_forward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		V_o_nbn_forward(depth);
		V_o_nob_forward(depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_lifo_in.getNextDataPtr();
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char old_state = 0;

	if (depth < depth_limiter_max)
	{
		if (cKernelClass.should_refine(depth, element_data))
			old_state = 3;
	}

	if (depth > depth_limiter_min)
	{
		if (old_state == 0)
		{
			if (cKernelClass.should_coarsen(depth, element_data))
			{
				old_state = 2;
			}
		}
	}

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	// spread refine/coarsening information
	// spread coarsening information
	if (new_state == 2)
	{
		comm_left_edge_stack->push(2);
		comm_left_edge_stack->push(2);
	}
	else
	{
		comm_left_edge_stack->push(0);
		comm_left_edge_stack->push(0);
	}
	outgoingEdgeStateInformation &= 0;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

void V_o_nbn_forward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		V_e_bnn_forward(depth);
		V_e_nno_forward(depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_lifo_in.getNextDataPtr();
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char old_state = 0;

	if (depth < depth_limiter_max)
	{
		if (cKernelClass.should_refine(depth, element_data))
			old_state = 3;
	}

	if (depth > depth_limiter_min)
	{
		if (old_state == 0)
		{
			if (cKernelClass.should_coarsen(depth, element_data))
			{
				old_state = 2;
			}
		}
	}

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	// spread refine/coarsening information
	comm_left_edge_stack->push((outgoingEdgeStateInformation >> 2) & 1);
	// spread coarsening information
	if (new_state == 2)
	{
		comm_right_edge_stack->push(2);
	}
	else
	{
		comm_right_edge_stack->push(0);
	}
	outgoingEdgeStateInformation &= 0;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

void V_o_bnn_forward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		V_e_nnb_forward(depth);
		V_e_nbo_forward(depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_lifo_in.getNextDataPtr();
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char old_state = 0;

	if (depth < depth_limiter_max)
	{
		if (cKernelClass.should_refine(depth, element_data))
			old_state = 3;
	}

	if (depth > depth_limiter_min)
	{
		if (old_state == 0)
		{
			if (cKernelClass.should_coarsen(depth, element_data))
			{
				old_state = 2;
			}
		}
	}

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	// spread refine/coarsening information
	// spread coarsening information
	if (new_state == 2)
	{
		comm_right_edge_stack->push(2);
		comm_right_edge_stack->push(2);
	}
	else
	{
		comm_right_edge_stack->push(0);
		comm_right_edge_stack->push(0);
	}
	outgoingEdgeStateInformation &= 0;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

void V_e_nnb_forward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		V_o_bnn_forward(depth);
		V_o_non_forward(depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_lifo_in.getNextDataPtr();
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char old_state = 0;

	if (depth < depth_limiter_max)
	{
		if (cKernelClass.should_refine(depth, element_data))
			old_state = 3;
	}

	if (depth > depth_limiter_min)
	{
		if (old_state == 0)
		{
			if (cKernelClass.should_coarsen(depth, element_data))
			{
				old_state = 2;
			}
		}
	}

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	// spread refine/coarsening information
	comm_right_edge_stack->push((outgoingEdgeStateInformation >> 2) & 1);
	// spread coarsening information
	if (new_state == 2)
	{
		comm_left_edge_stack->push(2);
	}
	else
	{
		comm_left_edge_stack->push(0);
	}
	outgoingEdgeStateInformation &= 0;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

void V_e_boo_forward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		V_o_obn_forward(depth);
		V_o_oob_forward(depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_lifo_in.getNextDataPtr();
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char edge_left_trigger = comm_left_edge_stack->pop();
	incomingEdgeStateTransfer |= (edge_left_trigger&1) << 0;
	unsigned char edge_right_trigger = comm_left_edge_stack->pop();
	incomingEdgeStateTransfer |= (edge_right_trigger&1) << 1;
	unsigned char old_state = 0;

	if (depth < depth_limiter_max)
	{
		if (cKernelClass.should_refine(depth, element_data))
			old_state = 3;
	}

	if ((edge_left_trigger == 2) && (edge_right_trigger == 2))
	{
		if (depth > depth_limiter_min)
		{
			if (old_state == 0)
			{
				if (cKernelClass.should_coarsen(depth, element_data))
				{
					old_state = 2;
				}
			}
		}
	}

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	if (new_state != 2)
	{
		if ((edge_left_trigger == 2) || (edge_right_trigger == 2))
			repeat_traversal = true;
	}
	else
	{
	}

	// spread refine/coarsening information
	outgoingEdgeStateInformation &= 3;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

void V_o_oob_forward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		V_e_ono_forward(depth);
		V_e_boo_forward(depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_lifo_in.getNextDataPtr();
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char hyp_trigger = comm_left_edge_stack->pop();
	incomingEdgeStateTransfer |= (hyp_trigger&1) << 2;
	unsigned char edge_right_trigger = comm_right_edge_stack->pop();
	incomingEdgeStateTransfer |= (edge_right_trigger&1) << 1;
	unsigned char old_state = 0;

	if (depth < depth_limiter_max)
	{
		if (cKernelClass.should_refine(depth, element_data))
			old_state = 3;
	}

	if (edge_right_trigger == 2)
	{
		if (depth > depth_limiter_min)
		{
			if (old_state == 0)
			{
				if (cKernelClass.should_coarsen(depth, element_data))
				{
					old_state = 2;
				}
			}
		}
	}

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	if (new_state != 2)
	{
		if ((edge_right_trigger == 2) || (hyp_trigger == 2))
			repeat_traversal = true;
	}
	else
	{
		if (hyp_trigger == 2)
			repeat_traversal = true;
	}

	// spread refine/coarsening information
	outgoingEdgeStateInformation &= 6;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

void V_o_boo_forward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		V_e_onb_forward(depth);
		V_e_obo_forward(depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_lifo_in.getNextDataPtr();
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char edge_right_trigger = comm_right_edge_stack->pop();
	incomingEdgeStateTransfer |= (edge_right_trigger&1) << 1;
	unsigned char edge_left_trigger = comm_right_edge_stack->pop();
	incomingEdgeStateTransfer |= (edge_left_trigger&1) << 0;
	unsigned char old_state = 0;

	if (depth < depth_limiter_max)
	{
		if (cKernelClass.should_refine(depth, element_data))
			old_state = 3;
	}

	if ((edge_left_trigger == 2) && (edge_right_trigger == 2))
	{
		if (depth > depth_limiter_min)
		{
			if (old_state == 0)
			{
				if (cKernelClass.should_coarsen(depth, element_data))
				{
					old_state = 2;
				}
			}
		}
	}

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	if (new_state != 2)
	{
		if ((edge_left_trigger == 2) || (edge_right_trigger == 2))
			repeat_traversal = true;
	}
	else
	{
	}

	// spread refine/coarsening information
	outgoingEdgeStateInformation &= 3;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

void V_e_obo_forward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		V_o_oon_forward(depth);
		V_o_boo_forward(depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_lifo_in.getNextDataPtr();
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char hyp_trigger = comm_right_edge_stack->pop();
	incomingEdgeStateTransfer |= (hyp_trigger&1) << 2;
	unsigned char edge_left_trigger = comm_left_edge_stack->pop();
	incomingEdgeStateTransfer |= (edge_left_trigger&1) << 0;
	unsigned char old_state = 0;

	if (depth < depth_limiter_max)
	{
		if (cKernelClass.should_refine(depth, element_data))
			old_state = 3;
	}

	if (edge_left_trigger == 2)
	{
		if (depth > depth_limiter_min)
		{
			if (old_state == 0)
			{
				if (cKernelClass.should_coarsen(depth, element_data))
				{
					old_state = 2;
				}
			}
		}
	}

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	if (new_state != 2)
	{
		if ((edge_left_trigger == 2) || (hyp_trigger == 2))
			repeat_traversal = true;
	}
	else
	{
		if (hyp_trigger == 2)
			repeat_traversal = true;
	}

	// spread refine/coarsening information
	outgoingEdgeStateInformation &= 5;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

void V_e_nbn_forward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		V_o_nnn_forward(depth);
		V_o_bon_forward(depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_lifo_in.getNextDataPtr();
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char old_state = 0;

	if (depth < depth_limiter_max)
	{
		if (cKernelClass.should_refine(depth, element_data))
			old_state = 3;
	}

	if (depth > depth_limiter_min)
	{
		if (old_state == 0)
		{
			if (cKernelClass.should_coarsen(depth, element_data))
			{
				old_state = 2;
			}
		}
	}

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	// spread refine/coarsening information
	comm_right_edge_stack->push((outgoingEdgeStateInformation >> 2) & 1);
	// spread coarsening information
	if (new_state == 2)
	{
		comm_left_edge_stack->push(2);
	}
	else
	{
		comm_left_edge_stack->push(0);
	}
	outgoingEdgeStateInformation &= 0;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

void V_o_obo_forward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		V_e_bno_forward(depth);
		V_e_ooo_forward(depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_lifo_in.getNextDataPtr();
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char hyp_trigger = comm_left_edge_stack->pop();
	incomingEdgeStateTransfer |= (hyp_trigger&1) << 2;
	unsigned char edge_left_trigger = comm_right_edge_stack->pop();
	incomingEdgeStateTransfer |= (edge_left_trigger&1) << 0;
	unsigned char old_state = 0;

	if (depth < depth_limiter_max)
	{
		if (cKernelClass.should_refine(depth, element_data))
			old_state = 3;
	}

	if (edge_left_trigger == 2)
	{
		if (depth > depth_limiter_min)
		{
			if (old_state == 0)
			{
				if (cKernelClass.should_coarsen(depth, element_data))
				{
					old_state = 2;
				}
			}
		}
	}

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	if (new_state != 2)
	{
		if ((edge_left_trigger == 2) || (hyp_trigger == 2))
			repeat_traversal = true;
	}
	else
	{
		if (hyp_trigger == 2)
			repeat_traversal = true;
	}

	// spread refine/coarsening information
	outgoingEdgeStateInformation &= 5;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

void V_o_nnb_forward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		V_e_nnn_forward(depth);
		V_e_bno_forward(depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_lifo_in.getNextDataPtr();
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char old_state = 0;

	if (depth < depth_limiter_max)
	{
		if (cKernelClass.should_refine(depth, element_data))
			old_state = 3;
	}

	if (depth > depth_limiter_min)
	{
		if (old_state == 0)
		{
			if (cKernelClass.should_coarsen(depth, element_data))
			{
				old_state = 2;
			}
		}
	}

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	// spread refine/coarsening information
	comm_left_edge_stack->push((outgoingEdgeStateInformation >> 2) & 1);
	// spread coarsening information
	if (new_state == 2)
	{
		comm_right_edge_stack->push(2);
	}
	else
	{
		comm_right_edge_stack->push(0);
	}
	outgoingEdgeStateInformation &= 0;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

void V_e_oob_forward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		V_o_bon_forward(depth);
		V_o_ooo_forward(depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_lifo_in.getNextDataPtr();
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char hyp_trigger = comm_right_edge_stack->pop();
	incomingEdgeStateTransfer |= (hyp_trigger&1) << 2;
	unsigned char edge_right_trigger = comm_left_edge_stack->pop();
	incomingEdgeStateTransfer |= (edge_right_trigger&1) << 1;
	unsigned char old_state = 0;

	if (depth < depth_limiter_max)
	{
		if (cKernelClass.should_refine(depth, element_data))
			old_state = 3;
	}

	if (edge_right_trigger == 2)
	{
		if (depth > depth_limiter_min)
		{
			if (old_state == 0)
			{
				if (cKernelClass.should_coarsen(depth, element_data))
				{
					old_state = 2;
				}
			}
		}
	}

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	if (new_state != 2)
	{
		if ((edge_right_trigger == 2) || (hyp_trigger == 2))
			repeat_traversal = true;
	}
	else
	{
		if (hyp_trigger == 2)
			repeat_traversal = true;
	}

	// spread refine/coarsening information
	outgoingEdgeStateInformation &= 6;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

void V_e_bbn_forward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		V_o_nbn_forward(depth);
		V_o_bob_forward(depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_lifo_in.getNextDataPtr();
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char old_state = 0;

	if (depth < depth_limiter_max)
	{
		if (cKernelClass.should_refine(depth, element_data))
			old_state = 3;
	}

	if (depth > depth_limiter_min)
	{
		if (old_state == 0)
		{
			if (cKernelClass.should_coarsen(depth, element_data))
			{
				old_state = 2;
			}
		}
	}

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	// spread refine/coarsening information
	// spread coarsening information
	if (new_state == 2)
	{
		comm_left_edge_stack->push(2);
	}
	else
	{
		comm_left_edge_stack->push(0);
	}
	outgoingEdgeStateInformation &= 0;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

void V_o_bbo_forward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		V_e_bnb_forward(depth);
		V_e_obo_forward(depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_lifo_in.getNextDataPtr();
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char edge_left_trigger = comm_right_edge_stack->pop();
	incomingEdgeStateTransfer |= (edge_left_trigger&1) << 0;
	unsigned char old_state = 0;

	if (depth < depth_limiter_max)
	{
		if (cKernelClass.should_refine(depth, element_data))
			old_state = 3;
	}

	if (edge_left_trigger == 2)
	{
		if (depth > depth_limiter_min)
		{
			if (old_state == 0)
			{
				if (cKernelClass.should_coarsen(depth, element_data))
				{
					old_state = 2;
				}
			}
		}
	}

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	if (new_state != 2)
	{
		if (edge_left_trigger == 2)
			repeat_traversal = true;
	}
	else
	{
	}

	// spread refine/coarsening information
	outgoingEdgeStateInformation &= 1;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

void V_e_nbb_forward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		V_o_bnn_forward(depth);
		V_o_bon_forward(depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_lifo_in.getNextDataPtr();
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char old_state = 0;

	if (depth < depth_limiter_max)
	{
		if (cKernelClass.should_refine(depth, element_data))
			old_state = 3;
	}

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	// spread refine/coarsening information
	comm_right_edge_stack->push((outgoingEdgeStateInformation >> 2) & 1);
	outgoingEdgeStateInformation &= 0;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

void V_o_nbb_forward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		V_e_bnn_forward(depth);
		V_e_bno_forward(depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_lifo_in.getNextDataPtr();
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char old_state = 0;

	if (depth < depth_limiter_max)
	{
		if (cKernelClass.should_refine(depth, element_data))
			old_state = 3;
	}

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	// spread refine/coarsening information
	comm_left_edge_stack->push((outgoingEdgeStateInformation >> 2) & 1);
	outgoingEdgeStateInformation &= 0;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

void V_e_obb_forward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		V_o_bon_forward(depth);
		V_o_boo_forward(depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_lifo_in.getNextDataPtr();
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char hyp_trigger = comm_right_edge_stack->pop();
	incomingEdgeStateTransfer |= (hyp_trigger&1) << 2;
	unsigned char old_state = 0;

	if (depth < depth_limiter_max)
	{
		if (cKernelClass.should_refine(depth, element_data))
			old_state = 3;
	}

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	if (new_state != 2)
	{
		if (hyp_trigger == 2)
			repeat_traversal = true;
	}
	else
	{
		if (hyp_trigger == 2)
			repeat_traversal = true;
	}

	// spread refine/coarsening information
	outgoingEdgeStateInformation &= 4;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

void V_o_obb_forward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		V_e_bno_forward(depth);
		V_e_boo_forward(depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_lifo_in.getNextDataPtr();
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char hyp_trigger = comm_left_edge_stack->pop();
	incomingEdgeStateTransfer |= (hyp_trigger&1) << 2;
	unsigned char old_state = 0;

	if (depth < depth_limiter_max)
	{
		if (cKernelClass.should_refine(depth, element_data))
			old_state = 3;
	}

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	if (new_state != 2)
	{
		if (hyp_trigger == 2)
			repeat_traversal = true;
	}
	else
	{
		if (hyp_trigger == 2)
			repeat_traversal = true;
	}

	// spread refine/coarsening information
	outgoingEdgeStateInformation &= 4;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

void V_o_bnb_forward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		V_e_nnb_forward(depth);
		V_e_bbo_forward(depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_lifo_in.getNextDataPtr();
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char old_state = 0;

	if (depth < depth_limiter_max)
	{
		if (cKernelClass.should_refine(depth, element_data))
			old_state = 3;
	}

	if (depth > depth_limiter_min)
	{
		if (old_state == 0)
		{
			if (cKernelClass.should_coarsen(depth, element_data))
			{
				old_state = 2;
			}
		}
	}

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	// spread refine/coarsening information
	// spread coarsening information
	if (new_state == 2)
	{
		comm_right_edge_stack->push(2);
	}
	else
	{
		comm_right_edge_stack->push(0);
	}
	outgoingEdgeStateInformation &= 0;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

void V_e_bob_forward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		V_o_bbn_forward(depth);
		V_o_oob_forward(depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_lifo_in.getNextDataPtr();
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char edge_right_trigger = comm_left_edge_stack->pop();
	incomingEdgeStateTransfer |= (edge_right_trigger&1) << 1;
	unsigned char old_state = 0;

	if (depth < depth_limiter_max)
	{
		if (cKernelClass.should_refine(depth, element_data))
			old_state = 3;
	}

	if (edge_right_trigger == 2)
	{
		if (depth > depth_limiter_min)
		{
			if (old_state == 0)
			{
				if (cKernelClass.should_coarsen(depth, element_data))
				{
					old_state = 2;
				}
			}
		}
	}

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	if (new_state != 2)
	{
		if (edge_right_trigger == 2)
			repeat_traversal = true;
	}
	else
	{
	}

	// spread refine/coarsening information
	outgoingEdgeStateInformation &= 2;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

static const int number_of_recursion_functions = 44;
typedef void (TThisClass::*TRecursiveMethod)(int);
enum ESFCMethod{
	SFC_METHOD_DEFAULT = 0,
	SFC_METHOD_FORCE_FORWARD = (1 << 0),
	SFC_METHOD_FORCE_BACKWARD = (1 << 1),
	SFC_METHOD_NEW_TO_OLD_EDGE_TYPES = (1 << 2),
	SFC_METHOD_OLD_TO_NEW_EDGE_TYPES = (1 << 3),
	SFC_METHOD_LIMITER___ = (1 << 4)
};

template <int specialMode = 0>
TRecursiveMethod getSFCMethod(CTriangle_Factory &i_cTriangleFactory)
{
	static TRecursiveMethod methodArray [2] [27] [2] =
	{
	{
	{
		&TThisClass::V_e_nnn_forward ,
		nullptr 
	} ,
	{
		&TThisClass::V_e_nno_forward ,
		nullptr 
	} ,
	{
		&TThisClass::V_e_nnb_forward ,
		nullptr 
	} ,
	{
		nullptr ,
		nullptr 
	} ,
	{
		&TThisClass::V_e_noo_forward ,
		nullptr 
	} ,
	{
		nullptr ,
		nullptr 
	} ,
	{
		&TThisClass::V_e_nbn_forward ,
		nullptr 
	} ,
	{
		&TThisClass::V_e_nbo_forward ,
		nullptr 
	} ,
	{
		&TThisClass::V_e_nbb_forward ,
		nullptr 
	} ,
	{
		&TThisClass::V_e_onn_forward ,
		nullptr 
	} ,
	{
		&TThisClass::V_e_ono_forward ,
		nullptr 
	} ,
	{
		&TThisClass::V_e_onb_forward ,
		nullptr 
	} ,
	{
		nullptr ,
		nullptr 
	} ,
	{
		&TThisClass::V_e_ooo_forward ,
		nullptr 
	} ,
	{
		&TThisClass::V_e_oob_forward ,
		nullptr 
	} ,
	{
		nullptr ,
		nullptr 
	} ,
	{
		&TThisClass::V_e_obo_forward ,
		nullptr 
	} ,
	{
		&TThisClass::V_e_obb_forward ,
		nullptr 
	} ,
	{
		&TThisClass::V_e_bnn_forward ,
		nullptr 
	} ,
	{
		&TThisClass::V_e_bno_forward ,
		nullptr 
	} ,
	{
		&TThisClass::V_e_bnb_forward ,
		nullptr 
	} ,
	{
		nullptr ,
		nullptr 
	} ,
	{
		&TThisClass::V_e_boo_forward ,
		nullptr 
	} ,
	{
		&TThisClass::V_e_bob_forward ,
		nullptr 
	} ,
	{
		&TThisClass::V_e_bbn_forward ,
		nullptr 
	} ,
	{
		&TThisClass::V_e_bbo_forward ,
		nullptr 
	} ,
	{
		&TThisClass::V_e_bbb_forward ,
		nullptr 
	} 
	} ,
	{
	{
		&TThisClass::V_o_nnn_forward ,
		nullptr 
	} ,
	{
		nullptr ,
		nullptr 
	} ,
	{
		&TThisClass::V_o_nnb_forward ,
		nullptr 
	} ,
	{
		&TThisClass::V_o_non_forward ,
		nullptr 
	} ,
	{
		&TThisClass::V_o_noo_forward ,
		nullptr 
	} ,
	{
		&TThisClass::V_o_nob_forward ,
		nullptr 
	} ,
	{
		&TThisClass::V_o_nbn_forward ,
		nullptr 
	} ,
	{
		nullptr ,
		nullptr 
	} ,
	{
		&TThisClass::V_o_nbb_forward ,
		nullptr 
	} ,
	{
		&TThisClass::V_o_onn_forward ,
		nullptr 
	} ,
	{
		nullptr ,
		nullptr 
	} ,
	{
		nullptr ,
		nullptr 
	} ,
	{
		&TThisClass::V_o_oon_forward ,
		nullptr 
	} ,
	{
		&TThisClass::V_o_ooo_forward ,
		nullptr 
	} ,
	{
		&TThisClass::V_o_oob_forward ,
		nullptr 
	} ,
	{
		&TThisClass::V_o_obn_forward ,
		nullptr 
	} ,
	{
		&TThisClass::V_o_obo_forward ,
		nullptr 
	} ,
	{
		&TThisClass::V_o_obb_forward ,
		nullptr 
	} ,
	{
		&TThisClass::V_o_bnn_forward ,
		nullptr 
	} ,
	{
		nullptr ,
		nullptr 
	} ,
	{
		&TThisClass::V_o_bnb_forward ,
		nullptr 
	} ,
	{
		&TThisClass::V_o_bon_forward ,
		nullptr 
	} ,
	{
		&TThisClass::V_o_boo_forward ,
		nullptr 
	} ,
	{
		&TThisClass::V_o_bob_forward ,
		nullptr 
	} ,
	{
		&TThisClass::V_o_bbn_forward ,
		nullptr 
	} ,
	{
		&TThisClass::V_o_bbo_forward ,
		nullptr 
	} ,
	{
		&TThisClass::V_o_bbb_forward ,
		nullptr 
	} 
	} 
	} 	;

	assert(i_cTriangleFactory.triangleType != CTriangle_Enums::TRIANGLE_TYPE_INVALID);
	assert(i_cTriangleFactory.evenOdd != CTriangle_Enums::EVEN_ODD_INVALID);

		assert(i_cTriangleFactory.edgeTypes.hyp != CTriangle_Enums::EDGE_TYPE_INVALID);
		assert(i_cTriangleFactory.edgeTypes.left != CTriangle_Enums::EDGE_TYPE_INVALID);
		assert(i_cTriangleFactory.edgeTypes.right != CTriangle_Enums::EDGE_TYPE_INVALID);
		CTriangle_Enums::EEdgeType hyp, left, right;
		if (specialMode == 0)
		{
			hyp = i_cTriangleFactory.edgeTypes.hyp;
			right = i_cTriangleFactory.edgeTypes.right;
			left = i_cTriangleFactory.edgeTypes.left;
		}
		else if (specialMode & SFC_METHOD_NEW_TO_OLD_EDGE_TYPES)
		{
			hyp = (i_cTriangleFactory.edgeTypes.hyp == CTriangle_Enums::EDGE_TYPE_NEW ? CTriangle_Enums::EDGE_TYPE_OLD : i_cTriangleFactory.edgeTypes.hyp);
			right = (i_cTriangleFactory.edgeTypes.right == CTriangle_Enums::EDGE_TYPE_NEW ? CTriangle_Enums::EDGE_TYPE_OLD : i_cTriangleFactory.edgeTypes.right);
			left = (i_cTriangleFactory.edgeTypes.left == CTriangle_Enums::EDGE_TYPE_NEW ? CTriangle_Enums::EDGE_TYPE_OLD : i_cTriangleFactory.edgeTypes.left);
		}
		else if (specialMode & SFC_METHOD_OLD_TO_NEW_EDGE_TYPES)
		{
			hyp = (i_cTriangleFactory.edgeTypes.hyp == CTriangle_Enums::EDGE_TYPE_OLD ? CTriangle_Enums::EDGE_TYPE_NEW : i_cTriangleFactory.edgeTypes.hyp);
			right = (i_cTriangleFactory.edgeTypes.right == CTriangle_Enums::EDGE_TYPE_OLD ? CTriangle_Enums::EDGE_TYPE_NEW : i_cTriangleFactory.edgeTypes.right);
			left = (i_cTriangleFactory.edgeTypes.left == CTriangle_Enums::EDGE_TYPE_OLD ? CTriangle_Enums::EDGE_TYPE_NEW : i_cTriangleFactory.edgeTypes.left);
		}
	#if DEBUG
		else
		{
			assert(false);
		}
	#endif
	CTriangle_Enums::EDirection direction;
	if (specialMode & SFC_METHOD_FORCE_FORWARD)
	{
		direction = CTriangle_Enums::DIRECTION_FORWARD;
	}
	else if (specialMode & SFC_METHOD_FORCE_BACKWARD)
	{
		direction = CTriangle_Enums::DIRECTION_BACKWARD;
	}
	else
	{
		direction = i_cTriangleFactory.traversalDirection;
	}

		assert(i_cTriangleFactory.traversalDirection != CTriangle_Enums::DIRECTION_INVALID);
	assert(i_cTriangleFactory.hypNormal != CTriangle_Enums::NORMAL_INVALID);
#if DEBUG
	assert(methodArray[i_cTriangleFactory.evenOdd][hyp*9+right*3+left][direction] != nullptr);
#endif
	return methodArray[i_cTriangleFactory.evenOdd][hyp*9+right*3+left][direction];
}
